#ifndef LIBRARIES_REGEXP_H
#define LIBRARIES_REGEXP_H
/*
**	$VER: regexp.h 37.1 (19.2.98)
**
**	(L) Copyleft 1998 Matthias Bethke
*/

#ifndef DOS_DOS_H
#include "dos/dos.h"
#endif


#define REXPERR_NULLARG -1						/* "NULL argument" */
#define REXPERR_REXPTOOBIG -2					/* "regexp too big */
#define REXPERR_TOOMANYPARENS -3				/* "too many parentheses" */
#define REXPERR_UNMATCHEDPARENS -4			/* "unmatched parentheses */
#define REXPERR_JUNKONEND -5					/* "junk on end" (should never happen) */
#define REXPERR_ARSKPLUSCBE -6				/* "*+ operand could be empty" */
#define REXPERR_NESTEDARSKQMPLUS -7			/* "nested *?+" */
#define REXPERR_INVALIDABRKTRANGE -8		/* "invalid [] range" */
#define REXPERR_UNMATCHEDABRKT -9			/* "unmatched []" */
#define REXPERR_INTERNALURP -10				/* "internal urp" */
#define REXPERR_QMPLUSARSKFN -11				/* "?+* follows nothing" */
#define REXPERR_TRAILINGDSLASH -12			/* "trailing \\" */
/* returned by RegMatch() only */
#define REXPERR_CORRUPTEDPROG -13			/* "corrupted program" */
#define REXPERR_CORRUPTEDMEM -14				/* "corrupted memory" */
#define REXPERR_CORRUPTEDPTRS -15			/* "corrupted pointers" */
#define REXPERR_INTERNALFOULUP -16			/* "internal foulup" */

/*
** better don't mess with struct regexp, use it as an abstract
** handle for expressions only!
*/

#define NSUBEXP  10
typedef struct regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;


#endif /* LIBRARIES_REGEXP_H */
